library flutter_exception_ui_custom;

import 'dart:async';

import 'package:flutter/material.dart';

typedef Builder = void Function();
typedef ErrorCallback = dynamic Function(Object error, StackTrace stackTrace);

class ExceptionCatchUtil {
  static void init(Builder builder,
      {Widget customErrorUI, ErrorCallback errorCallback}) {
    FlutterError.onError = (FlutterErrorDetails details) async {
      //转发至Zone中
      Zone.current.handleUncaughtError(details.exception, details.stack);
    };

    ErrorWidget.builder = (FlutterErrorDetails flutterErrorDetails) {
      return customErrorUI ??
          Scaffold(
            body: Center(
              child: Text("Here is something error"),
            ),
          );
    };

    runZonedGuarded(() async {
      builder();
    }, (error, stackTrace) async {
      if (errorCallback != null) {
        errorCallback(error, stackTrace);
      }
    });
  }
}
