import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';

import 'package:flutter_exception_ui_custom/flutter_exception_ui_custom.dart';

void main() {
  test('simple use', () {
    ExceptionCatchUtil.init(() {
      runApp(MaterialApp());
    });
  });

  Widget widget = Scaffold(
    body: Center(
      child: Text("Custom Error UI"),
    ),
  );

  test('custom Error UI', () {
    ExceptionCatchUtil.init(() {
      runApp(MaterialApp());
    },customErrorUI: widget);
  });

  test('custom Error UI and error use', () {
    ExceptionCatchUtil.init(() {
      runApp(MaterialApp());
    },customErrorUI: widget,errorCallback: (Object error, StackTrace stackTrace){
      print("error "+error.toString());
      print("stackTrace "+stackTrace.toString());
    });
  });
}
